// verzia beta2 - delphi 5

unit VelaKorUnit;

interface

uses
  Graphics, KorUnit;

type
  VelaKor = class
  private
    k0:array of Kor;
    pk0:integer;
    function getKor(i:integer):Kor;
  public
    constructor Create;
    destructor Destroy; override;
    procedure UrobKor(x:real = 0; y:real = 0; u:real = 0); overload;
    procedure UrobKor(nk:Kor); overload;
    procedure ZrusKor(i:integer); overload;
    procedure ZrusKor(nk:Kor); overload;
    procedure Uprac;

    procedure Dopredu(d:real);
    procedure Vpravo(u:real);
    procedure Vlavo(u:real);
    procedure ZmenSmer(u:real);
    procedure ZmenXY(x,y:real);
    procedure PresunXY(x,y:real);
    procedure PH;
    procedure PD;
    procedure ZmenPero(nd:boolean);
    procedure ZmenFP(nfp:TColor);
    procedure ZmenHP(nhp:integer);
    procedure Ukaz;
    procedure Skry;
    procedure ZmenTvar(const obrys:array of real);
    procedure ZmenFarbuTvaru(f:TColor);
    procedure ZmenHrubkuTvaru(h:integer);

    procedure Pis(const s:string);
    procedure Vypln(fv:TColor);
    function  Blizko(x,y:real):Kor;

    property  k[i:integer]:Kor read getKor;
    property  pk:integer read pk0;
  end;

implementation

constructor VelaKor.Create;
begin
  pk0:=0;
end;

destructor VelaKor.Destroy;
var i:integer;
begin
  for i:=0 to pk0-1 do k0[i].Free;
  inherited;
end;

function VelaKor.getKor(i:integer):Kor;
begin
  if (i<0) or (i>=pk0) then Result:=nil
  else Result:=k0[i];
end;

procedure VelaKor.UrobKor(x,y,u:real);
begin
  UrobKor(Kor.Create(x,y,u));
end;

procedure VelaKor.UrobKor(nk:Kor);
begin
  if pk0+1>=high(k0) then SetLength(k0,Length(k0)+10);
  k0[pk0]:=nk;
  inc(pk0);
end;

procedure VelaKor.ZrusKor(i:integer);
begin
  if (i<0) or (i>=pk0) then exit;
  k0[i].Free; k0[i]:=nil;
end;

procedure VelaKor.ZrusKor(nk:Kor);
var i:integer;
begin
  i:=0; while (i<pk0) and (k0[i]<>nk) do inc(i);
  if i<pk0 then ZrusKor(i);
end;

procedure VelaKor.Uprac;
var i,j:integer;
begin
  j:=0;
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      begin k0[j]:=k0[i]; inc(j) end;
  pk0:=j;
end;

////////////////////////////////////////////////////////

procedure VelaKor.Dopredu(d:real);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].Dopredu(d);
  Naraz(b);
end;

procedure VelaKor.Vpravo(u:real);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].Vpravo(u);
  Naraz(b);
end;

procedure VelaKor.Vlavo(u:real);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].Vlavo(u);
  Naraz(b);
end;

procedure VelaKor.ZmenSmer(u:real);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenSmer(u);
  Naraz(b);
end;

procedure VelaKor.ZmenXY(x,y:real);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenXY(x,y);
  Naraz(b);
end;

procedure VelaKor.PresunXY(x,y:real);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].PresunXY(x,y);
  Naraz(b);
end;

procedure VelaKor.PH;
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].PH;
  Naraz(b);
end;

procedure VelaKor.PD;
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].PD;
  Naraz(b);
end;

procedure VelaKor.ZmenPero(nd:boolean);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenPero(nd);
  Naraz(b);
end;

procedure VelaKor.ZmenFP(nfp:TColor);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenFP(nfp);
  Naraz(b);
end;

procedure VelaKor.ZmenHP(nhp:integer);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenHP(nhp);
  Naraz(b);
end;

procedure VelaKor.Ukaz;
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].Ukaz;
  Naraz(b);
end;

procedure VelaKor.Skry;
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].Skry;
  Naraz(b);
end;

procedure VelaKor.ZmenTvar(const obrys:array of real);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenTvar(obrys);
  Naraz(b);
end;

procedure VelaKor.ZmenFarbuTvaru(f:TColor);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenFarbuTvaru(f);
  Naraz(b);
end;

procedure VelaKor.ZmenHrubkuTvaru(h:integer);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].ZmenHrubkuTvaru(h);
  Naraz(b);
end;

procedure VelaKor.Pis(const s:string);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].Pis(s);
  Naraz(b);
end;

procedure VelaKor.Vypln(fv:TColor);
var i:integer;
    b:boolean;
begin
  b:=Naraz(true);
  for i:=0 to pk0-1 do
    if k0[i]<>nil then
      k0[i].Vypln(fv);
  Naraz(b);
end;

function  VelaKor.Blizko(x,y:real):Kor;
var i:integer;
begin
  i:=pk0-1;
  while (i>=0) and ((k0[i]=nil) or not k0[i].Blizko(x,y)) do dec(i);
  if i<0 then Result:=nil else Result:=k0[i];
end;

end.

